Option Explicit

Dim FoobarSyncBanner,LF : LF=chr(10)
FoobarSyncBanner="FOOBARSYNC 0.9.5 - Sync MediaLibrary and Playlists from Foobar2000 to targets"&LF&"http://foobarsync.lima-city.de"
Dim FoobarSyncHome : FoobarSyncHome=left(replace(WScript.ScriptFullName, "\"&WScript.ScriptName, ""),500)
Dim FB2kCOMserverObj, MediaLibraryObj, TrackListObj, PlaylistsObj, CurrentConfigFile, CurrentConfigFileDrive, QueueFilesPrefix, FolderTemp

Const ForReading=1   'Open a file for reading only. 
Const ForWriting=2   'Open a file for writing.
Const ForAppending=8 'Open a file and write to the end of the file.

Dim s1,s2,s3,i,i1,i2,BlackListChrs, WhiteListChrs
Dim ProgressTimer, Progress, ProgressTarget, TimerStart, ProgressTimeTotal, TimeLeft, ProgressVisible, LastProgress, LastOut

Dim Tasks, RunID, DebugLev, NoPause, NoWarnings

Dim MediaName,MaxItemsOnTarget,ReserveFreeSpace,MLsyncFlag,MLsyncBaseDir,PLsyncBaseDir,PlayListFormat,PlaylistDir
Dim MLbasePath, PLbasePath, MLPLnested, MLPLnestedBase
Dim Qfiles2copy, Qfiles2convert, Qsize2copy, QfilesConverted, Qsize2convert, QfilesCopied, Qfiles2ignoreByError,Qfiles2ignoreByRule,Qfiles2OK,Qsize2OK
Dim Qfiles2OphanedFiles,Qsize2OphanedFiles,Qfiles2OphanedFolders, OKfilesQueue, MaxFFMPEGThreads
Dim WarningCount
ReDim PRESERVE MLSyncTargetDir(1,0) : ReDim PRESERVE PLSyncTargetDir(1,0)
ReDim PRESERVE ReplaceChrs(1,0)
ReDim PRESERVE ConvertFormats(4,0) : ReDim PRESERVE SyncRules(2,0)
ReDim PRESERVE PLregExRepl(1,0) 
ReDim PRESERVE PLRegExExclude(100,0) : ReDim PRESERVE PLRegExInclude(100,0)

Dim SrcPath, SrcSize, SrcCodec, SrcBitRate, SrcCodecBR, SrcTitle
Dim DstPath, DstSize, DstConvertFormat

Dim CopyQueue, ConvertQueue, OphanedFilesQueue, OphanedFoldersQueue
Dim ShellObj1, objShellEnvVar, FlagFileObj, FSobj, FSobj2
Set ShellObj1 = CreateObject("WScript.Shell")
Set objShellEnvVar = ShellObj1.Environment("PROCESS")
objShellEnvVar("FFREPORT") = "file=c\:\\ffprobe.log"
Set FSobj = CreateObject("Scripting.FileSystemObject")
Set FSobj2 = CreateObject("Scripting.FileSystemObject")

Dim BSstr,SCstr
for i = 1 to 78
  BSstr=BSstr&chr(8)
  SCstr=SCstr&" "
  Next

' RegEx setup
Dim objRegExp : Set objRegExp = New Regexp
objRegExp.IgnoreCase = True
objRegExp.Global = True

FUNCTION ask (SomeText)
	out 0, LF&SomeText
	ask=wscript.StdIn.Readline()
END Function

SUB ClrProgress
	if ProgressVisible then
		wscript.StdOut.write left(BSstr,len(LastProgress))&left(SCstr,len(LastProgress))&left(BSstr,len(LastProgress))
		LastProgress=""
		LastOut=""
		ProgressVisible=false
		End If
END Sub		

SUB InitTimer (ProgressStartValue, ProgressTargetValue)
	ClrProgress
	Progress=ProgressStartValue
	TimerStart=Now()
	ProgressTimer=timer
	ProgressTarget=ProgressTargetValue
	ProgressTimeTotal=""
	ProgressVisible=false
END Sub

SUB WriteProgress (s)
	ClrProgress
	if len(LastOut)+len(s)>79 then 
		wscript.StdOut.write LF
		LastOut=""
		End If
	LastProgress=s
	wscript.StdOut.write LastProgress
	ProgressVisible=true
END Sub
 
SUB CheckProgress
Dim ProgressInPercent, SecElapsed, ProgressEndDate, SecLeft, RestTimeStr, ProgressPerSec
	if ProgressTarget=0 then exit sub
	if abs(timer-ProgressTimer)=>2 then
		SecElapsed=datediff("S",TimerStart,now())
		if (Progress/ProgressTarget<0.002) or (SecElapsed<2) then Exit Sub
		ProgressEndDate=formatdatetime(Dateadd("S", ProgressTarget/Progress*SecElapsed, TimerStart),0)
		SecLeft=csng(datediff("S",now(),ProgressEndDate))
		if SecLeft<31000 then
			RestTimeStr=TimeSerial(0,0,SecLeft)
			else
			RestTimeStr=TimeSerial(0,SecLeft/60,0)
			End If
		if SecElapsed+SecLeft<31000 then
			ProgressTimeTotal=TimeSerial(0,0,SecElapsed+SecLeft)
			else
			ProgressTimeTotal=TimeSerial(0,(SecElapsed+SecLeft)/60,0)
			End If
		ProgressPerSec=round(Progress/ProgressTarget/SecElapsed*100,2)
		ProgressInPercent=FormatNumberLZ(round(Progress/ProgressTarget*100) & "%",3,"0","Right")
		TimeLeft=NotEmpty(hour(RestTimeStr),FormatNumberLZ(hour(RestTimeStr),2,"0","Right")&":")& _
		FormatNumberLZ(minute(RestTimeStr),2,"0","Right")&":"&FormatNumberLZ(second(RestTimeStr),2,"0","Right")
		ProgressTimer=timer+2
		WriteProgress " "&ProgressInPercent&"  ("&TimeLeft&" left)"
		End If
END Sub

SUB out (OutLevel, Str)
	if DebugLev>=OutLevel then 
		ClrProgress
		if OutLevel>1 then LastOut=LF&Str&" (lvl"&OutLevel&")" else LastOut=LF&Str
		wscript.StdOut.write LastOut
		End If
END Sub

SUB ShowSyntax
	out 1, LF&"Tasks:"
	out 1, "	M Sync		- sync Foobar MediaLibrary part of IDfile"
	out 1, "	P Playlists	- sync Foobar Playlists part of IDfile"
	out 1, "	T Test		- analyse but M/P but don't copy/convert/delete files"  
	out 1, "	R Test		- run through roots of driveletters D-Z and run all *.ID"  
	out 1, ""
	out 1, "Options:"
	out 1, "	RunID=IDfile|path	Run specific IDfile or all in path"
	out 1, "	DebugLev=n		Debuglevel n=0-5 (1=default, 5=Entwicklung)"
	out 1, "	NoPause			don't pause after analysis"	
	out 1, "	NoWarnings		no warnings prompts"
	out 1, "	DebugLev=n		Debuglevel (1=default, 5=insane)"&LF
	wscript.quit
END Sub

FUNCTION TaskChk (CheckOptions,CheckIfToF)
	TaskChk=true
	if CheckIfToF then
		for i=1 to len(CheckOptions)
			if instr(1,Tasks,mid(CheckOptions,i,1),1)=0 then TaskChk=false
			Next
		else
		for i=1 to len(CheckOptions)
			if instr(1,Tasks,mid(CheckOptions,i,1),1)>0 then TaskChk=false
			Next
		End if
END Function

FUNCTION ChkCMDLPar (VarName, isOptional, RegexWLcleanStr)
Dim s
	ChkCMDLPar=false
	if VarType(Eval(VarName))=0 then
		if Not isOptional then OutError "ChkCMDLPar:Argument missing: "&VarName,1
		else
		if VarType(Eval(VarName))=8 then
			if RegexWLcleanStr<>"" then
				s=RegexWLclean(Eval(VarName), RegexWLcleanStr)
				else
				s=cstr(Eval(VarName))
				End If
			if cstr(Eval(VarName))<>s then OutError "ChkCMDLPar: Check Command line: "&VarName,1 else ChkCMDLPar=true
			else
			Out 5, "ChkCMDLPar:"&VarName&" (VarType "&VarType(Eval(VarName))&")="&Eval(VarName)
			ChkCMDLPar=true
			End If
		End If
END Function	

SUB GetCMDlineParameters
Dim i1
	out 1, ""
	out 1, FoobarSyncBanner
	out 1, ""
	for each i1 in WScript.Arguments
		out 4,"GetCMDlineParameters:ArgumentItem: "&i1
		i1=replace(i1,"/?","Help")
		if instr(i1,"=")>0 then
			if mid(i1,1,instr(i1,"=")-1)<>RegexWLclean(mid(i1,1,instr(i1,"=")-1), "[A-Z]") then OutError "GetCMDlineParameters: "&mid(i1,1,instr(i1,"=")-1),1
			ExecuteGlobal "Dim "&mid(i1,1,instr(i1,"=")-1)
			ExecuteGlobal mid(i1,1,instr(i1,"=")-1)&"="""&mid(i1,instr(i1,"=")+1,255)&""""
			Out 5,"GetCMDlineParameters:Set: (VarType "&VarType(Eval(mid(i1,1,instr(i1,"=")-1)))&"): "&i1
			else
			if RegexWLclean(i1,"[A-Z]")=i1 then
				ExecuteGlobal "Dim "&i1
				ExecuteGlobal i1&"=true"
				Out 4,"GetCMDlineParameters:Set: (VarType "&VarType(Eval(i1))&"): "&i1&"=True"
				End If
			End If
		Next
END Sub

FUNCTION RegExSnR (StringIn, SearchPattern, ReplacePattern)
Dim s 
	out 5,"RegExSnR:In.....: "&StringIn
	out 5,"RegExSnR:Pattern: "&SearchPattern
	objRegExp.Pattern = SearchPattern
	s=objRegExp.Replace (StringIn, ReplacePattern)
	RegExSnR = s
	out 5,"RegExSnR:Output.: "&s
END Function

FUNCTION RunReplaceChrs (s)
Dim i
	Out 5, "RunReplaceChrs:In.: "&S
	for i = 1 to ubound(ReplaceChrs,2)
		s=RegExSnR(s,"["&ReplaceChrs(0,i)&"]+",ReplaceChrs(1,i))
		Next
	RunReplaceChrs=s
	Out 5, "RunReplaceChrs:Out: "&S
END Function

FUNCTION RegexWLclean (StrToClean, WhiteListChrs)
Dim objMatch, colMatch, s 
	out 5,"RegexWLclean:In.: "&StrToClean
	objRegExp.Pattern = WhiteListChrs
	Set colMatch = objRegExp.Execute(StrToClean)
		For each objMatch in colMatch
		s=s&objMatch.Value
		Next 
	RegexWLclean = s
	out 5,"RegexWLclean:Out: "&s
END Function

FUNCTION FormatNumberLZ (ValIn, Stellen, FormatChr, LeftRight)
Dim i,s1
	FormatNumberLZ=replace(cstr(ValIn)," ","")
	if Stellen-Len(FormatNumberLZ)<1 then exit function
	for i=1 to Stellen 
	  s1=s1&FormatChr
	  Next
	if ucase(LeftRight)="LEFT" then
		FormatNumberLZ=FormatNumberLZ&mid(s1,1,Stellen-Len(FormatNumberLZ))
		else
		FormatNumberLZ=mid(s1,1,Stellen-Len(FormatNumberLZ))&FormatNumberLZ
		End If
END Function
	
SUB GetIniValue (fname, KeySearchFor, VarToStoreIn, isOptional, Seperator)
Dim tmp,found
	out 5, "GetIniValue:Search: "&KeySearchFor&" (VarType "&VarType(VarToStoreIn)&")"
	found=0
	on error resume next
	Dim inStream: Set inStream = FSobj.openTextFile(fname,ForReading)
	if err.number<>0 then OutError "GetIniValue: Error reading configuration file '"&fname&"'",1
	while not inStream.AtEndOfStream 
		tmp=instream.readline
		if (instr(1, tmp, KeySearchFor&"=", 1)=1) then
			found=found+1
			tmp=mid(tmp,instr(1, tmp, KeySearchFor&"=", 1)+len(KeySearchFor)+1,1024)
			if (VarType(VarToStoreIn)>=8192) and (tmp<>"") then
				ReDim PRESERVE VarToStoreIn (ubound(VarToStoreIn,1),ubound(VarToStoreIn,2)+1)
				tmp=split(tmp,Seperator)
				out 5,"GetIniValue:Seperator="&Seperator
				i1=0
				for each i in tmp
					VarToStoreIn(i1,ubound(VarToStoreIn,2))=i
					out 3,"GetIniValue:"&KeySearchFor&"("&i1&","&ubound(VarToStoreIn,2)& _
					")="&VarToStoreIn(i1,ubound(VarToStoreIn,2))&" (VarType "&VarType(VarToStoreIn)&")"
					i1=i1+1
					Next
				else
				if tmp<>"" then
					VarToStoreIn=tmp
					out 3,"GetIniValue:"&KeySearchFor&"="&VarToStoreIn&" (VarType "&VarType(KeySearchFor)&")"
					End If
				End If
			End If
		wend
	inStream.close
	if found=0 then 
		if isOptional=true then
			if (VarType(VarToStoreIn)<8192) then VarToStoreIn=""
			exit sub
			else
			OutError "GetIniValue: '"&KeySearchFor&"' not found in "&CurrentConfigFile.name&"!",1
			End If 
		else
		out 5,"GetIniValue:"&KeySearchFor&": Found "&found&" times."
		End If
	on error goto 0
END Sub

SUB AnalysisConsole
	ShellObj1.SendKeys "CLS + {ENTER}" 
	out 1, "Menu...."
	ask ("Next?")
END Sub

SUB ShowStats
	out 1, LF&"ANALYSIS DONE: '"&CurrentConfigFile.path&"':"
	out 1, "Existing items don't need action : "&Qfiles2OK&" ("&round(Qsize2OK/1048576)&" MB)"
	out 1, "Items that were ignored by rule .: "&Qfiles2ignoreByRule
	out 1, "Items that were ignored by error : "&Qfiles2ignoreByError
	out 1, "Ophaned files to delete .........: "&Qfiles2OphanedFiles&" ("&round(Qsize2OphanedFiles/1048576)&" MB)"
	out 1, LF&"Copy queue - items to copy ......: "&Qfiles2copy&" ("&round(Qsize2copy/1048576)&" MB)"
	out 1, "Convert queue - items to convert : "&Qfiles2convert&" ("&round(Qsize2convert/1048576)&" MB ca.)"
	out 1, "SUM OF AUDIO ITEMS AFTER SYNC ...: "&Qfiles2OK+Qfiles2copy+Qfiles2convert&" ("&round((Qsize2OK+Qsize2copy+Qsize2convert)/1048576)&" MB ca.)"&LF
	
	out 1, "Free space now / after sync .....: "&round(FSobj.getdrive(CurrentConfigFileDrive).FreeSpace/1048576)&" MB / "&round((FSobj.getdrive(CurrentConfigFileDrive).FreeSpace-Qsize2copy-Qsize2convert+Qsize2OphanedFiles)/1048576)&" MB"&LF

	if Qfiles2ignoreByError>0 then OutError LF&Qfiles2ignoreByError&" item were ignored!"&LF,0
	if Qfiles2OK+Qfiles2copy+Qfiles2convert>MaxItemsOnTarget then
		OutError LF&"This sync would exceed 'MaxItemsOnTarget="&MaxItemsOnTarget&"' by "&Qfiles2OK+Qfiles2copy+Qfiles2convert-MaxItemsOnTarget&" items!",0
		if TaskChk("t",false) then
			SELECT CASE ucase(ask ("I=Ignore	S=Stop at "&MaxItemsOnTarget&"		 A=Abort >> "))
				Case "I":
				MaxItemsOnTarget=999999999
				Case else:
				Tasks="t"
				End Select
			End If
		NoPause=true
		End If
	if (FSobj.getdrive(CurrentConfigFileDrive).FreeSpace-Qsize2copy-Qsize2convert+Qsize2OphanedFiles<ReserveFreeSpace*1048576) AND _
	(Qfiles2convert+Qfiles2copy>0) then
		OutError LF&"This sync will exceed 'ReserveFreeSpace="&ReserveFreeSpace&"' !",0
		if TaskChk("t",false) then
			SELECT CASE ucase(ask ("I=Ignore		A=Abort >> "))
				Case "I":
				ReserveFreeSpace=1
				Case else:
				Tasks="t"
				End Select
			End If
		NoPause=true
		End If
	if (NoPause=false) or ((Qfiles2convert+Qfiles2copy+Qfiles2ignoreByError=0) _
	and (Qfiles2OphanedFiles+Qfiles2ignoreByError=0)) then
		out 1,"You may now take a look on the target to check the file/folder structure."&LF&"(you can disable this pause with parameter 'NoPause')"
		s1=ucase(ask ("ENTER=continue with synchronization    S=STOP and quit >> "))
		if s1="S" then
			out 1,""
			wscript.quit(0)
			else
			if s1="A" then AnalysisConsole
			End If
		End If	
	'out 1, ""
END Sub

SUB RunAnalysis
	InitQueueFiles
	out 1,"Preparing target for analysis..."
	if MLPLnested then
		ExecuteIt "cmd.exe /c del """&MLPLnestedBase&"\*.*FLAG"" /s /f /q", true, 0
		ExecuteIt "cmd.exe /c attrib """&MLPLnestedBase&"\*.*"" -h -r -s -a /S /D", true, 0
		else
		if TaskChk("m",true) then 
			ExecuteIt "cmd.exe /c del """&MLbasePath&"\*.*FLAG"" /s /f /q", true, 0
			ExecuteIt "cmd.exe /c attrib """&MLbasePath&"\*.*"" -h -r -s -a /S /D", true, 0
			End If
		if TaskChk("p",true) then 
			ExecuteIt "cmd.exe /c del """&PLbasePath&"\*.*FLAG"" /s /f /q", true, 0
			ExecuteIt "cmd.exe /c attrib """&PLbasePath&"\*.*"" -h -r -s -a /S /D", true, 0
			ExecuteIt "cmd.exe /c del """&PlaylistDir&"\*.m3u"" /q", true, 0
			End If
		End If
	if TaskChk("m",true) then ProcessMediaLibrary
	if TaskChk("p",true) then 
		ProcessPlayLists
		WScript.DisconnectObject PlaylistsObj
		set PlaylistsObj=Nothing
		End If
	set FB2kCOMserverObj=nothing
	out 1, "Searching target for ophaned files and folders..."
	if MLPLnested then 
		CollectOphanedFilesAndFolders(MLPLnestedBase)
		else
		if TaskChk("m",true) then CollectOphanedFilesAndFolders(MLbasePath)
		if TaskChk("p",true) then CollectOphanedFilesAndFolders(PLbasePath)
		End If
	on error resume next
	ConvertQueue.close
	CopyQueue.close
	OphanedFilesQueue.close
	OphanedFoldersQueue.close
	OKfilesQueue.close
	on error goto 0
END Sub

FUNCTION BuildBasePath (PathToBuild)
	BuildBasePath=CurrentConfigFileDrive&"\"&PathToBuild
	Do while instr(BuildBasePath,"\\")>0
		BuildBasePath=replace(BuildBasePath,"\\","\")
		Loop 
	if right(BuildBasePath,1)="\" then BuildBasePath=left(BuildBasePath,len(BuildBasePath)-1)
END Function

FUNCTION CollectOphanedFilesAndFolders (objFolder)
Dim objFile, objSubFolder, OphanedFoldersCount, OphanedFilesCount, OphanedFilesTmpStr
	CollectOphanedFilesAndFolders=false
	if isobject(objFolder)=false then if FSobj.folderexists(objFolder) then set objFolder=FSobj.getfolder(objFolder) else EXIT Function
	OphanedFilesCount=0 : OphanedFoldersCount=0
	For each objSubFolder in objFolder.Subfolders
		if CollectOphanedFilesAndFolders(objSubFolder) then 
			OphanedFoldersCount=OphanedFoldersCount+1
			Qfiles2OphanedFolders=Qfiles2OphanedFolders+1
			OphanedFoldersQueue.writeline objSubFolder.path
			End If
        Next
    For each objFile in objFolder.Files
		if objFile.Attributes <> 32 then 
			OphanedFilesCount=OphanedFilesCount+1
			Qfiles2OphanedFiles=Qfiles2OphanedFiles+1
			Qsize2OphanedFiles=Qsize2OphanedFiles+objFile.size
			OphanedFilesTmpStr=OphanedFilesTmpStr&LF&objFile.Path
			out 3, "CollectOphanedFilesAndFolders: Ophaned file: '" &objFile.path&"'"
			else
			OKfilesQueue.writeline objFile.path
			End If
		Next
	if (objFolder.Files.Count+objFolder.Subfolders.Count) = (OphanedFoldersCount+OphanedFilesCount) then 
		CollectOphanedFilesAndFolders=true
		out 3, "CollectOphanedFilesAndFolders: Ophaned folder: '"&objFolder.name&"'"
		else
		if OphanedFilesCount>0 then OphanedFilesQueue.WriteLine OphanedFilesTmpStr
		End If
END Function

SUB LoadDefaults
	PLSyncBaseDir="" : MLSyncBaseDir="" : PlaylistDir="" 
	ReDim PRESERVE MLSyncTargetDir(1,0) : ReDim PRESERVE PLSyncTargetDir(1,0)
	PlayListFormat=0 : MaxFFMPEGThreads=1 : WarningCount=0
	ReDim PRESERVE ReplaceChrs(1,0)
	ReDim PRESERVE ConvertFormats(4,0) : ReDim PRESERVE SyncRules(2,0)
	ReDim PRESERVE PLregExRepl(1,0) 
	ReDim PRESERVE PLRegExExclude(100,0) : ReDim PRESERVE PLRegExInclude(100,0)
	Qfiles2convert=0 : Qfiles2copy=0 :	QfilesCopied=0 : QfilesConverted=0
	Qsize2copy=0 : Qsize2convert=0 : Qfiles2ignoreByError=0 : Qfiles2OK = 0
	Qfiles2ignoreByRule=0 : Qfiles2OphanedFiles=0 : Qsize2OphanedFiles=0 : Qfiles2OphanedFolders=0
	ReserveFreeSpace=1048576 : MaxItemsOnTarget=0 : MediaName=""
	WhiteListChrs = "[A-Z0-9-+#\.=]+"
	MLPLnested=false
END Sub	

FUNCTION CheckIDplausibility
	Dim IsOK, Passed
	Passed=true
	for i1=1 to ubound(SyncRules,2)
		REM out 1, "ChkSyncRules "&i1
		REM out 1, SyncRules(0,i1)&" VT:"&vartype(SyncRules(0,i1))
		REM out 1, SyncRules(1,i1)&" VT:"&vartype(SyncRules(1,i1))
		IsOK=0
		for i2=1 to ubound(ConvertFormats,2)
			if (ucase(ConvertFormats(0,i2))=ucase(SyncRules(2,i1))) or (ucase(SyncRules(2,i1))="COPY") or (ucase(SyncRules(2,i1))="IGNORE") then IsOK=1
			Next
		if IsOK=0 then 
			OutError "CheckIDplausibility: Not found ConvertFormats="&SyncRules(2,i1),0
			Passed=false
			End If
		Next
	if not Passed then OutError "CheckIDplausibility: Fix above errors in configuration file and retry." ,1
END Function

FUNCTION ConvClng (ByRef StringIn, IfNULL)
	on error resume next
	StringIn=clng(StringIn)
	if StringIn=0 then StringIn=IfNULL
	ConvClng=StringIn
	On error goto 0
END Function

SUB ProcessIniFile (CurrentConfigFile)
	LoadDefaults
	CurrentConfigFileDrive=FSobj.GetDriveName(CurrentConfigFile)
	out 1,""
	GetIniValue CurrentConfigFile.path,"MediaName",MediaName,true,""
	if MediaName<>"" then QueueFilesPrefix=FoobarSyncHome&"\tmp_"&RegexWLclean(MediaName,"[A-Z 0-9-+#@=!_a(){}$\[\]]+") else QueueFilesPrefix=FoobarSyncHome&"\tmp_"&CurrentConfigFile.name
	out 1,"*** PROCESSING '"&CurrentConfigFile.path&"' ("&MediaName&")"
	GetIniValue CurrentConfigFile.path,"MaxTitles",MaxItemsOnTarget,true,""
	if (ConvClng(MaxItemsOnTarget,0)>0) then OutError "MaxTitles was replaced by MaxItemsOnTarget !",0
	GetIniValue CurrentConfigFile.path,"MaxItemsOnTarget",MaxItemsOnTarget,true,""
	ConvClng MaxItemsOnTarget,99999999
	GetIniValue CurrentConfigFile.path,"MinSize",ReserveFreeSpace,true,""
	if (ConvClng(ReserveFreeSpace,0)>0) then OutError "MinSize was replaced by ReserveFreeSpace !",0
	GetIniValue CurrentConfigFile.path,"ReserveFreeSpace",ReserveFreeSpace,true,""
	ConvClng ReserveFreeSpace,1
	GetIniValue CurrentConfigFile.path,"MLsyncFlag",MLsyncFlag,false,""
	GetIniValue CurrentConfigFile.path,"PLRegExExclude",PLRegExExclude,true,","
	GetIniValue CurrentConfigFile.path,"PLRegExInclude",PLRegExInclude,true,","
	GetIniValue CurrentConfigFile.path,"MLSyncBaseDir",MLSyncBaseDir,false,""
	MLbasePath=BuildBasePath(MLSyncBaseDir)
	GetIniValue CurrentConfigFile.path,"MLSyncTargetDir",MLSyncTargetDir,false,""
	GetIniValue CurrentConfigFile.path,"PlaylistDir",PlaylistDir,false,""
	PlaylistDir=BuildBasePath(PlaylistDir)
	GetIniValue CurrentConfigFile.path,"PlayListFormat",PlayListFormat,true,""
	GetIniValue CurrentConfigFile.path,"PLSyncBaseDir",PLSyncBaseDir,false,""
	PLbasePath=BuildBasePath(PLSyncBaseDir)		
	GetIniValue CurrentConfigFile.path,"PLregExRepl",PLregExRepl,true,"*"
	GetIniValue CurrentConfigFile.path,"PLSyncTargetDir",PLSyncTargetDir,false,""
	if (instr(1,PLbasePath&"\",MLbasePath&"\",1)>0) or (instr(1,MLbasePath&"\",PLbasePath&"\",1)>0) then
		OutError "MLSyncBaseDir or PLSyncBaseDir are nested or same!",0
		MLPLnested=true
		if len(PLbasePath)>len(MLbasePath) then MLPLnestedBase=MLbasePath else MLPLnestedBase=PLbasePath
		if (TaskChk("t",true)) or (TaskChk("mp",true)) then 
			out 1,"(but because you specified Tasks="&Tasks&" FoobarSync will continue.)"
			else
			OutError "See last warning! You must run Tasks=MP to avoid file deletion!",1
			End If
		End If
	GetIniValue CurrentConfigFile.path,"ReplaceChrs",ReplaceChrs,true," "
	GetIniValue CurrentConfigFile.path,"WhiteListChrs",WhiteListChrs,true,""
	GetIniValue CurrentConfigFile.path,"ConvertFormats",ConvertFormats,false,"*"
	GetIniValue CurrentConfigFile.path,"SyncRules",SyncRules,false,"*"
	
	GetIniValue CurrentConfigFile.path,"MaxFFMPEGThreads",MaxFFMPEGThreads,true,""
	ConvClng MaxFFMPEGThreads,1
	CheckIDplausibility
	SetupComServer
	RunAnalysis
	ShowStats
	if ((TaskChk("t",false)) and ((len(PLSyncBaseDir)<=1) or (len(MLSyncBaseDir)<=1))) and (NoWarnings=false) then
		OutError LF&"PLSyncBaseDir and/or MLSyncBaseDirEs point to the root-folder!"&LF&"Make sure no important data is on target!",0
		if ucase(ask("Continue (Y/N)? "))<>"Y" then wscript.quit (1)
	End If
	FSobj.getfile(CurrentConfigFile.path).Attributes=32 ' Prevent Config file from deletion
	
	If MLPLnested then
		ExecuteIt "cmd.exe /c del """&MLPLnestedBase&"\*.*FLAG"" /s /f /q", true, 0
		else
		ExecuteIt "cmd.exe /c del """&MLbasePath&"\*.*FLAG"" /s /f /q", true, 0
		ExecuteIt "cmd.exe /c del """&PLbasePath&"\*.*FLAG"" /s /f /q", true, 0
		End If
	if TaskChk("t",false) then RemoveOphanedFiles
	if TaskChk("t",false) then 
		ProcessCopyFiles
		ProcessConvertFiles
		End If
	if WarningCount>0 then Out 1, "!!! There were "&WarningCount&" warnings !!!"
	out 1,"*** DONE PROCESSING OF '"&CurrentConfigFile.path&"' ("&MediaName&")"
END Sub

SUB BuildFullFolderPath (FullPath)
Dim i, i2, DirParts, ReducedPath
	if instrrev(FullPath,".")>0 then ReducedPath=left(FullPath,instrrev(FullPath,"\")-1) else ReducedPath=FullPath
	out 4, "BuildFullFolderPath: '"&ReducedPath&"'"
	if FSobj.folderexists(ReducedPath) then exit sub
	DirParts=Split(ReducedPath,"\")
	for i=ubound(DirParts) to 0 Step -1
		If FSobj.FolderExists(ReducedPath) Then
			' correct base found?? needs check!
			out 5, "BuildFullFolderPath: Building from existing base '"&ReducedPath&"'"
			for i2=i+1 to ubound(DirParts)
				ReducedPath=ReducedPath&"\"&DirParts(i2)
				out 5,"BuildFullFolderPath: Will create: '"&ReducedPath&"'"
				on error resume next
				FSobj2.createfolder(ReducedPath)
				if Err.Number<>0 then
					OutError "BuildFullFolderPath: "&Err.Number&" create folder '"&ReducedPath&"'",0
					else
					out 5, "BuildFullFolderPath: Created folder '"&ReducedPath&"'"
					End If
				on error goto 0
				Next
			Exit Sub
			else
			ReducedPath=left(ReducedPath,len(ReducedPath)-len(DirParts(i))-1)
			End If
		Next
END Sub

SUB RemoveOphanedFiles
Dim DeleteItem
	if Qfiles2OphanedFiles+Qfiles2OphanedFolders=0 then Exit Sub
	out 1, "Removing "&Qfiles2OphanedFiles&" ophaned files and "&Qfiles2OphanedFolders&" ophaned folders..."
	InitTimer 0, Qfiles2OphanedFiles+Qfiles2OphanedFolders
	OpenQueueFile OphanedFilesQueue,"_OphanedFiles.txt"
	on error resume next
	WHILE OphanedFilesQueue.atendofstream=false
		DeleteItem=OphanedFilesQueue.Readline
		out 3, "RemoveOphanedFiles:File '"&DeleteItem&"'"
		if DeleteItem<>"" then FSobj.deletefile(DeleteItem)
		if Err.Number<>0 then OutError "RemoveOphanedFiles:File '"&DeleteItem&"' (Error #"&Err.Number&"&)",0
		Progress=Progress+1
		CheckProgress
		Wend
	OpenQueueFile OphanedFoldersQueue,"_OphanedFolders.txt"
	WHILE OphanedFoldersQueue.atendofstream=false
		DeleteItem=OphanedFoldersQueue.Readline
		out 3, "RemoveOphanedFiles:Folder '"&DeleteItem&"'"
		FSobj.deletefolder(DeleteItem)
		if Err.Number<>0 then OutError "RemoveOphanedFiles:Folder '"&DeleteItem&"'",0
		Progress=Progress+1
		CheckProgress
		Wend
	OphanedFilesQueue.close
	OphanedFoldersQueue.close
	on error goto 0
END Sub

SUB ProcessCopyFiles
Dim Citem
	if Qfiles2copy=0 then Exit Sub
	out 1, "Processing copyqueue ("&Qfiles2copy&" items / ca. "&round(Qsize2copy/1048576)&" MB)..."
	OpenQueueFile CopyQueue,"_copy.txt"
	InitTimer 0, Qsize2copy
	WHILE CopyQueue.atendofstream=false
		Citem=split(CopyQueue.readline,"*")
		BuildFullFolderPath(Citem(1))
		if FSobj.getdrive(CurrentConfigFileDrive).freespace-ConvClng(Citem(2),0)<ReserveFreeSpace*1048576 then
			out 0, LF&"!!! STOPPED because 'ReserveFreeSpace="&ReserveFreeSpace&"' !"&LF
			CopyQueue.close
			Exit Sub
			End If
		on error resume next
		FSobj.copyfile Citem(0), Citem(1), true
		if Err.Number<>0 then OutError "ProcessCopyFiles: '"&Citem(0)&"' > '"&Citem(1)&"'",0 else out 3, "ProcessCopyFiles:Copied: "&Citem(1)
		on error goto 0
		out 4, "Processing copyqueue:Size: "&Citem(2)&"."
		QfilesCopied=QfilesCopied+1
		Progress=Progress+Citem(2)
		CheckProgress
		If QfilesCopied+QfilesConverted>MaxItemsOnTarget then
				out 1, LF&"!!! STOPPED because 'MaxItemsOnTarget="&MaxItemsOnTarget&"' !"&LF
				CopyQueue.close
				Exit Sub
				End If
		Wend
	CopyQueue.close
END Sub

SUB CreateFLAGfile (Filename,IsItem)
	out 5,"CreateFLAGfile:create: "&filename
	BuildFullFolderPath(Filename)
	on error resume next
	Set FlagFileObj = FSobj.CreateTextFile(filename,True)
	if Err.Number<>0 then 
		OutError "CreateFLAGfile: Access denied: '"&filename&"'",0
		Qfiles2ignoreByError=Qfiles2ignoreByError+1
		else 
		FlagFileObj.close
		End if
	Set FlagFileObj=Nothing
	on error goto 0
END Sub

FUNCTION ExecuteIt (cmdline,Wait,WindowVisible)
	out 4,"ExecuteIt: "&cmdline
	ExecuteIt = ShellObj1.Run (cmdline,WindowVisible,Wait)
END Function

		
SUB ProcessConvertFiles
Dim Citem, cmdLine,success
	if Qfiles2convert=0 then Exit Sub
	out 1, "Processing convert-queue ("&Qfiles2convert&" items / ca. "&round(Qsize2convert/1048576)&" MB)..."
	OpenQueueFile ConvertQueue,"_convert.txt"
	InitTimer 0, Qsize2convert
	executeit "cmd.exe /c del c:\ConvertJobFlag.* /q",false,0
	WHILE ConvertQueue.atendofstream=false
		Citem=split(ConvertQueue.readline,"*")
		if FSobj.getdrive(CurrentConfigFileDrive).freespace-ConvClng(Citem(3),0)<ReserveFreeSpace*1048576 then
			out 1, LF&"!!! STOPPED because 'ReserveFreeSpace="&ReserveFreeSpace&"' !"&LF
			CopyQueue.close
			Exit Sub
			End If
		out 3,"ProcessConvertFiles:"&Citem(1)
		BuildFullFolderPath(Citem(1))
		cmdline=chr(34)&FoobarSyncHome&"\ffmpeg.exe"&chr(34)&" -y -i "&chr(34)&Citem(0)&chr(34)&" "&citem(2)&" "&chr(34)&Citem(1)&chr(34)
		cmdline="cmd.exe /u /c echo&"&cmdline&" & del c:\ConvertJobFlag."&i
		success=false
		while Success=false
			for i=1 to MaxFFMPEGThreads
				if CheckFileExists("c:\ConvertJobFlag."&i)=false then
					CreateFLAGfile "c:\ConvertJobFlag."&i,false
					ExecuteIt cmdline,false,0
					wscript.sleep 400
					Success=true
					Exit For
					End If
				Next
			CheckProgress
			Wend
		QfilesConverted=QfilesConverted+1
		If QfilesCopied+QfilesConverted>MaxItemsOnTarget then
			out 1, LF&"!!! STOPPED because 'MaxItemsOnTarget="&MaxItemsOnTarget&"' !"&LF
			ConvertQueue.close	
			Exit Sub
			End If
		Progress=Progress+Citem(3)
		Wend
	ConvertQueue.close	
END Sub	

SUB SetupComServer()
	dim ProgID, tmp
	ProgID = "Foobar2000.Application.0.7"
	on error resume next
	tmp=FB2kCOMserverObj.Name
	IF (len(tmp)>0) then 
		on error goto 0
		exit sub
		End If
	out 1,"Connecting to Foobar2000 Comserver / launch Foobar2000 ..."
	set FB2kCOMserverObj = WScript.GetObject("", ProgID)
	if FB2kCOMserverObj.Name="" then
		set FB2kCOMserverObj = WScript.CreateObject(ProgID)
		if FB2kCOMserverObj.Name="" then OutError "No connection to Foobar2000! Foobar Comserver not set up correctly?",1
	End If
	on error goto 0
	set MediaLibraryObj=FB2kCOMserverObj.MediaLibrary
	out 5,FB2kCOMserverObj.Name & "(" & FB2kCOMserverObj.ApplicationPath & ")" & vbCRLF & FB2kCOMserverObj.ProfilePath
	set PlaylistsObj = FB2kCOMserverObj.Playlists
	set TrackListObj=MediaLibraryObj.GetTracks()
	out 2, "Foobar2000 COM-Server ready, "& TrackListObj.Count & " items in Medialibrary."
END Sub

sub CleanupTest()
	set ShellObj1 = nothing
	set FSobj = nothing
	set objRegExp = nothing
END Sub

FUNCTION GetExtension(path)
	GetExtension=right(path,len(path)-instrrev(path,".",-1,1))
END Function

SUB OutError (ErrorSting, Fatal)
	if Fatal then
		out 0,"ERROR:"&ErrorSting&LF
		wscript.quit(1)
		else
		out 1,"WARNING:"&ErrorSting
		WarningCount=WarningCount+1
		Err.Clear
		End If
END Sub

FUNCTION FormatFooTitle (FooItem, FormatString)
	on error resume next
	FormatFooTitle=FooItem.FormatTitle(FormatString)
	if (err.number<>0) AND (err.number<>7) then OutError "FormatFooTitle: Check Syntax in '"&FormatString&"' (error "& err.number&").",1
	on error goto 0
END Function

FUNCTION AssemblePath (itemX,TranslateVar)
Dim JoinedParts
	for i=1 to ubound(TranslateVar,2)
		out 4, "AssemblePath:In.: "&TranslateVar(0,i)
		JoinedParts=JoinedParts&"\"&RegexWLclean(RunReplaceChrs(FormatFooTitle(itemX,TranslateVar(0,i))),WhiteListChrs)
		next
	while (instr(JoinedParts," \")>0) OR (instr(JoinedParts,".\")>0) OR (instr(JoinedParts,"\\")>0)
		JoinedParts=replace(JoinedParts," \","\",1,-1,1)
		JoinedParts=replace(JoinedParts,".\","\")
		JoinedParts=replace(JoinedParts,"\\","\")
		Wend
	out 4, "AssemblePath:Out: "&JoinedParts
	AssemblePath=JoinedParts
END Function

FUNCTION NotEmpty (Var2Check, s)
	if (Var2Check="") or (Var2Check="?") or (cstr(Var2Check)="0") then 
		NotEmpty=""
		else
		if s<>"" then NotEmpty=s else NotEmpty=Var2Check
		End If
END Function

FUNCTION CheckFileExists (path)
	if FSobj.fileexists(path) then CheckFileExists=true else CheckFileExists=false
END Function

SUB InitQueueFiles
	out 3, "InitQueueFiles:Create '"&QueueFilesPrefix&"_copy.txt'"
	Set CopyQueue = FSobj.CreateTextFile(QueueFilesPrefix&"_copy.txt", True,1)
	out 3, "InitQueueFiles:Create '"&QueueFilesPrefix&"_convert.txt'"
	Set ConvertQueue = FSobj.CreateTextFile(QueueFilesPrefix&"_convert.txt", True,1)
	out 3, "InitQueueFiles:Create '"&QueueFilesPrefix&"_ophanedFiles.txt'"
	Set OphanedFilesQueue = FSobj.CreateTextFile(QueueFilesPrefix&"_ophanedFiles.txt", True,1)
	out 3, "InitQueueFiles:Create '"&QueueFilesPrefix&"_ophanedFolders.txt'"
	Set OphanedFoldersQueue = FSobj.CreateTextFile(QueueFilesPrefix&"_ophanedFolders.txt", True,1)
	out 3, "InitQueueFiles:Create '"&QueueFilesPrefix&"_FilesOK.txt'"
	Set OKfilesQueue = FSobj.CreateTextFile(QueueFilesPrefix&"_FilesOK.txt", True,1)
END Sub

SUB OpenQueueFile (FSobjobj,FileName)
	out 3, "OpenQueueFile:Open '"&FileName
	Set FSobjobj = FSobj.openTextFile(QueueFilesPrefix&FileName,ForReading,false,-1)
END Sub

SUB AddTforConvert
	if CheckFileExists(DstPath&"FLAG") then
		out 5,"AddTforConvert:Allready queued: "&SrcTitle
		else
		CreateFLAGfile DstPath&"FLAG", true
		ConvertQueue.WriteLine SrcPath&"*"&DstPath&"*"&ConvertFormats(2,DstConvertFormat)&"*"&DstSize
		Qfiles2convert=Qfiles2convert+1
		Qsize2convert=Qsize2convert+DstSize
		End If
END Sub

SUB AddTforCopy
	if CheckFileExists(DstPath&"FLAG") then
		out 3,"AddTforCopy:Allready queued: "&SrcTitle
		else
		CreateFLAGfile DstPath&"FLAG", true
		out 5, SrcPath&"*"&DstPath&"*"&DstSize
		CopyQueue.WriteLine SrcPath&"*"&DstPath&"*"&DstSize
		Qfiles2copy=Qfiles2copy+1
		Qsize2copy=Qsize2copy+DstSize
		End If
END Sub

SUB SetArchiveAttribute
	if not FSobj.getfile(DstPath).Attributes and 32 then
		FSobj.getfile(DstPath).Attributes=32
		Qfiles2OK=Qfiles2OK+1
		Qsize2OK=Qsize2OK+DstSize
		End If
END Sub

FUNCTION WouldConvertTo
Dim i, Evaluated, Match
	WouldConvertTo=-1  
	For i=1 to ubound(SyncRules,2)
		if WouldConvertTo>-1 then Exit For
		if instr(SyncRules(0,i),"$")>0 then
			s1=FormatFooTitle(i1,SyncRules(0,i))
			Out 3, "WouldConvertTo:Evaluate: "&SyncRules(0,i)&"="&s1
			Evaluated=s1
			End If
		if (instr(1,SrcCodec,SyncRules(0,i))=1) OR (Evaluated="T") then 
			SELECT CASE left(SyncRules(1,i),1)
				CASE ">":	If SrcBitRate=>cint(mid(SyncRules(1,i),2,20)) then Match=true
				CASE "<":	If SrcBitRate<=cint(mid(SyncRules(1,i),2,20)) then Match=true
				CASE ELSE	If SyncRules(1,i)="0" then Match=true else OutError "WouldConvertTo: SyncRules "&SyncRules(1,i),0
				END SELECT
			If match then
				Out 3,"WouldConvertTo:Match: "&SyncRules(0,i)&"*"&SyncRules(1,i)&SyncRules(2,i)
				if ucase(SyncRules(2,i))="COPY" then 
					WouldConvertTo=99
					Exit Function
					else
					if ucase(SyncRules(2,i))="IGNORE" then 
						WouldConvertTo=-2
						Exit Function
						else
						for i2=1 to ubound(ConvertFormats,2)
							if ucase(ConvertFormats(0,i2))=ucase(SyncRules(2,i)) then WouldConvertTo=i2
							Next
						End If
					End If
				End If
			End If
		Next
END Function

FUNCTION FFprobeRegEx (SearchRegEx)
	if ExecuteIt (chr(34)&FoobarSyncHome&"\ffprobe.exe "&chr(34)&" -print_format xml -show_streams "&chr(34)&DstPath&chr(34), true, 0)=0 then
		Set s1 = FSobj.OpenTextFile ("c:\ffprobe.log", ForReading)
		s2 = s1.ReadAll
		s1.close
		set s1 = Nothing
		FFprobeRegEx=RegExSearch (s2, "Stream #.* Audio:.*, "&SearchRegEx&" kb/s")
		else
		OutError "FFprobeRegEx:Execution failed:"&DstPath,0
		FFprobeRegEx=false
		End If 
END Function
		

FUNCTION FinalDecition (DstPathPrefix)
	Dim ExistingFileSize
	FinalDecition=0
	DstConvertFormat=WouldConvertTo
	SELECT CASE DstConvertFormat
		Case -1:	' Ignored - no rule has matched!
			FinalDecition=-1
		Case -2:		' Ignored by rule - no error.
			FinalDecition=-2
			exit function
		Case 99:	' Rule says COPY! Just check size if exists.
			if CheckFileExists(DstPath)=True then
				DstSize=FSobj.getfile(DstPath).size
				if SrcSize<>DstSize then FinalDecition=1
				else
				DstSize=FormatFooTitle(i1,"%filesize%")
				FinalDecition=1
				End If
		CASE else
		
			' Change extension to target format and add suffix to filename if configured so
			SELECT CASE left(ConvertFormats(4,DstConvertFormat),1)
				CASE "?":	' Use ffprobe and check!
					DstPath=mid(DstPath,1,instrrev(DstPath,".",-1,1))&ConvertFormats(1,DstConvertFormat)
				CASE "":	' Use simple calulation for target filesize
					DstPath=mid(DstPath,1,instrrev(DstPath,".",-1,1))&ConvertFormats(1,DstConvertFormat)
				CASE else:	' Use filenamesuffix to identify / set target filename
					DstPath=mid(DstPath,1,instrrev(DstPath,".",-1,1)-1)&mid(ConvertFormats(4,DstConvertFormat),1,20)&"."&ConvertFormats(1,DstConvertFormat)
				END SELECT
			out 3, "FinalDecition:DstPath="&dstpath

			' Check if DstPath exists
			if CheckFileExists(DstPath) then ExistingFileSize=FSobj.getfile(DstPath).size else ExistingFileSize=0
			DstSize=ConvertFormats(3,DstConvertFormat)*125*FormatFooTitle(i1,"%length_seconds%")

			' Make decision what to do
			SELECT CASE left(ConvertFormats(4,DstConvertFormat),1)
				CASE "?":	' Use ffprobe and check!
					if ExistingFileSize>0 then 
						if FFprobeRegEx(ConvertFormats(3,DstConvertFormat)) then 
							DstSize=ExistingFileSize
							FinalDecition=0
							End If 
							else
						FinalDecition=2
						End If
				CASE "":	' Use simple calulation for target filesize
					if (SrcBitRate>0) and (abs((DstSize-ExistingFileSize)/DstSize)>0.1) then FinalDecition=2
				CASE else
					if ExistingFileSize=0 then FinalDecition=2
				END SELECT
		END SELECT
	' Report Result
	SELECT CASE FinalDecition
		Case -1: ' ignored by error / missing rule
			out 1,"FinalDecition:Ignored: "&SrcCodec&": "&SrcTitle
			Qfiles2ignoreByError=Qfiles2ignoreByError+1
		Case -2: ' ignored by a rule
			Qfiles2ignoreByRule=Qfiles2ignoreByRule+1
		Case 0: 'OK, do nothing
			out 4, "FinalDecition:OK: "&SrcTitle
		Case 1:	'copy
			out 2, "FinalDecition:Copy: "&SrcCodecBR&":" &SrcTitle
		Case 2:	'convert
			out 2, "FinalDecition:Conv: "&SrcCodecBR&">"&ConvertFormats(0,DstConvertFormat)&" [is/shld:"&round(ExistingFileSize/1024)&"k/"&round(DstSize/1024)&"k diff "&round((ExistingFileSize-DstSize)/DstSize*100)&"%]: "&SrcTitle
		END SELECT
END Function

FUNCTION ItemRunner (DstPathPrefix, TranslateVar)
	ItemRunner=false
	SrcPath=mid(i1.path,8,512)
	SrcCodec=FormatFooTitle(i1,"%codec%-[%codec_profile%]")
	SrcTitle=FormatFooTitle(i1,"%title%")
	if CheckFileExists(SrcPath) then
		SrcSize=FSobj.getfile(SrcPath).size
		DstPath=DstPathPrefix&AssemblePath (i1, TranslateVar)
		SrcBitRate=ConvClng(FormatFooTitle(i1,"%Bitrate%"),0)
		SrcCodecBR=SrcCodec&"@"&SrcBitRate
		SELECT CASE FinalDecition (DstPathPrefix)
			Case -1:		' Ignored file (no rule matched) 	' Qfiles2ignoreByError
			Case -2:		' Ignored file (ignored by rule) 	' Qfiles2ignoreByRule
			Case 0:			SetArchiveAttribute					' Qfiles2OK
			Case 1:			AddTforCopy							' Qfiles2copy
			Case 2:			AddTforConvert						' Qfiles2convert
			END SELECT
		else
		OutError "ItemRunner:SourceFileNotExist: "&SrcPath,0
		End If
	Progress=Progress+1
	CheckProgress
END Function

FUNCTION PLregExReplaces (Instr)
Dim i
	PLregExReplaces=Instr
	for i =  1 to ubound(PLregExRepl,2)
		PLregExReplaces=RegExSnR(PLregExReplaces, PLregExRepl(0,i), PLregExRepl(1,i))
		Next
END Function

FUNCTION RegExSearch (StringIn, SearchPattern)
Dim s 
	out 5,"RegExSearch: StringIn.....: "&StringIn
	out 5,"RegExSearch: SearchPattern: "&SearchPattern
	RegExSearch=false
	if (SearchPattern<>"") then
		objRegExp.Pattern = SearchPattern
		set s = objRegExp.Execute (StringIn)
		out 5,"RegExSearch: Hits.........: "&s.count
		if s.count>0 then RegExSearch = true 
		End If
	out 5,"RegExSearch: Result.......: "&RegExSearch
END Function

FUNCTION CheckPLregExExclude (PLItem)
Dim i
	CheckPLregExExclude=false
	if ubound(PLRegExExclude,2)=0 then exit function
	for i =  0 to ubound(PLRegExExclude,1)
		if PLRegExExclude(i,1)<>"" then 
			out 5, "*"&PLItem.name&"*="&PLRegExExclude(i,1)&"="&RegExSearch("*"&PLItem.name&"*", PLRegExExclude(i,1))
			If (RegExSearch("*"&PLItem.name&"*", PLRegExExclude(i,1))) then 
				CheckPLregExExclude=true
				out 2,"PLRegExExclude: "&PLItem.name
				exit for
				End If
			End If
		Next
END Function

FUNCTION CheckPLregExInclude (PLItem)
Dim i
	CheckPLregExInclude=false
	if ubound(PLRegExInclude,2)=0 then exit function
	for i =  0 to ubound(PLRegExInclude,1)
		if PLRegExInclude(i,1)<>"" then 	
			out 5, "*"&PLItem.name&"*="&PLRegExInclude(i,1)&"="&RegExSearch("*"&PLItem.name&"*", PLRegExInclude(i,1))
			If (RegExSearch("*"&PLItem.name&"*", PLRegExInclude(i,1))) then 
				CheckPLregExInclude=true
				out 2,"PLRegExInclude: "&PLItem.name
				exit for
				End If
			End If
		Next
END Function

SUB ProcessPlaylists()
dim tmp, tmp2, PLfile,tl1, PlaylistCounter, PlaylistItemsCounter, PlaylistItemsTotal
	PlaylistCounter=0 : PlaylistItemsCounter=0 : PlaylistItemsTotal=0
	for each tmp in PlaylistsObj
		PlaylistItemsTotal=PlaylistItemsTotal+tmp.GetTracks().Count
		if (CheckPLregExExclude(tmp)=false) or (CheckPLregExInclude(tmp)=true) then
			PlaylistCounter=PlaylistCounter+1
			PlaylistItemsCounter=PlaylistItemsCounter+tmp.GetTracks().Count
			End If
		Next
	out 1, "Analysing "&PlaylistItemsCounter&" items in "&PlaylistCounter&" playlists (out of "&PlaylistItemsTotal&" items in "&PlaylistsObj.count&" playlists)"
	InitTimer 0,PlaylistItemsCounter
	for each tmp in PlaylistsObj
	if (CheckPLregExExclude(tmp)=false) or (CheckPLregExInclude(tmp)=true) then
		out 2,".playlist '" & tmp.Name & "' ("&tmp.GetTracks().Count&")"
		tmp2=PlaylistDir&"\"&tmp.Name&".m3u"
		set tl1 = tmp.gettracks()
		BuildFullFolderPath tmp2
		Set PLfile = FSobj.CreateTextFile(tmp2, True)
		if PlayListFormat=1 then PLfile.writeline "#EXTM3U"
		for each i1 in tl1
			'*** Compare to PLSyncBaseDir not jet implemented!
			ItemRunner PLbasePath, PLSyncTargetDir
			if PlayListFormat=1 then 
				PLfile.writeline "#EXTINF:"&FormatFooTitle(i1,"%length_seconds%,EXT:[%Artist% - ][%Title%]")
				PLfile.writeline PLregExReplaces(mid(DstPath,4,1024))
				else
				PLfile.writeline PLregExReplaces(mid(DstPath,4,1024))
				End If
			Next
		PLfile.close
		End If
	next
	set tl1=nothing
END Sub

SUB ProcessMediaLibrary
	set TrackListObj = TrackListObj.GetTracks(MLsyncFlag)  ' leerer/kein String gibt alle zurck.
	InitTimer 0,TrackListObj.count
	out 1, "Processing "&ProgressTarget&" items in MediaLibrary..."
	out 3, "ProcessMediaLibrary:Querey: '"&MLsyncFlag&"'"
	for each i1 in TrackListObj 
		ItemRunner MLbasePath,MLSyncTargetDir
		next
	set TrackListObj = Nothing
END Sub

SUB RunDriveletters
Dim i, objDrive, folder
	Out 1,"Processing search for configuation files in root of drives D-Z..."
	For Each objDrive in FSobj.Drives
		if instr("ABC",objDrive.DriveLetter)=0 then
			on error resume next
			Out 3,"searching "&objDrive.DriveLetter&":\*.id ("&round(objDrive.FreeSpace/1048576)&"MB free)..."
			if objDrive.IsReady then 	
				Set folder = FSobj.getfolder(cstr(objDrive.DriveLetter)&":\.")
				if err.number=0 then
					For Each CurrentConfigFile in Folder.Files
						If FSobj.GetExtensionName(CurrentConfigFile)="id"Then
							ProcessIniFile CurrentConfigFile
							End If
						Next
					End If
					on error goto 0
				End If
			End If
		Next
END Sub

FUNCTION FindRunID (FileOrFolder)
	Dim TestFile, TestFolder
	if FSobj.Fileexists(FileOrFolder) then FindRunID=FSobj.getfile(FileOrFolder).path
	if FSobj.FolderExists(FileOrFolder) then 
		set TestFolder=FSobj.getfolder(FileOrFolder)
		For each TestFile in TestFolder.Files
			if FSobj.GetExtensionName(TestFile)="id" then FindRunID=TestFile.path
			Next
		End If
END Function

' ################################## BEGIN

wscript.sleep 3000

FolderTemp = FSobj.GetAbsolutePathName(".")
DebugLev=1

GetCMDlineParameters
if FSobj.fileexists(FoobarSyncHome&"\ffmpeg.exe")=false then OutError "ffmpeg.exe missing in '"&FoobarSyncHome&"'",1
if FSobj.fileexists(FoobarSyncHome&"\ffprobe.exe")=false then OutError "ffprobe.exe missing in '"&FoobarSyncHome&"'",1

if (ChkCMDLPar ("Help",true,"")) then ShowSyntax ""
if ChkCMDLPar ("DebugLev",true,"[0-5]")=false then OutError "DebugLev: Check Syntax.",1
DebugLev=cint(DebugLev)
if ChkCMDLPar ("Tasks",false,"[MRPTC]")=false then OutError "Parameter Tasks missing. Check command line.",1

if (ChkCMDLPar ("RunID",true,"")=true) AND (TaskChk("r",true)) then OutError "RunID AND Tasks=R are not allowed simultaneously.",1
if (RunID="") AND (TaskChk("r",false)) then OutError "Nothing to do. Check command line syntax!",1
if (TaskChk("p",false)) and (TaskChk("m",false)) then OutError "Nothing to do. Tasks doesn't contain M or P !",1
If ChkCMDLPar ("NoPause",true,"[A-Z]")=true then NoPause=True else NoPause=false
If ChkCMDLPar ("NoWarnings",true,"[A-Z]")=true then NoWarnings=True else NoWarnings=false

if TaskChk("r",true) then RunDriveletters
if len(RunID)>0 then 
	if FSobj.fileexists(FindRunID(RunID))=false then
		OutError "RunID: file not found in folder / does not exist: "&RunID,1
		else
		set CurrentConfigFile=FSobj.getfile(FindRunID(RunID))
		ProcessIniFile CurrentConfigFile
		End If
	End If

ShellObj1.CurrentDirectory = FolderTemp
CleanupTest
out 1, "FOOBARSYNC ENDS NOW."&LF